module Cucumber
  module Ast
    class Examples
      def initialize(line, keyword, name, outline_table)
        @keyword, @name, @outline_table = keyword, name, outline_table
      end

      def accept(visitor)
        visitor.visit_examples_name(@keyword, @name)
        @outline_table.accept(visitor, nil)
      end

      def at_lines?(lines)
        lines.empty? || lines.index(@line) || @outline_table.at_lines?(lines)
      end

      def to_sexp
        [:examples, @keyword, @name, @outline_table.to_sexp]
      end
    end
  end
end
